<?php
namespace RotinaEstoque\Services\Planning;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class HomeService {
  public function __construct($entityManager, $environment){
    $this->connection = $entityManager->getConnection();
    $this->environment = $environment;
  }
  
  public function beginTransaction() {
    $this->connection->beginTransaction();
  }
  
  public function commit() {
    $this->connection->commit();
  }
  
  public function rollback() {
    $this->connection->rollback();
  }

  public function planningWithdrawalData($params) {
    $sql = "SELECT PE.IDLANCDTMEN, PE.IDLANCDTMAI, CASE WHEN PG.IDUTILDTPROC = 'S' THEN NVL(PF.DTPROCESSA,SYSDATE) ELSE SYSDATE END AS DTPROCESSA, 
                       NVL(PE.NRDIASSAID,0) AS NRDIASSAID, NVL(PE.NRDIASSAIDPD,0) AS NRDIASSAIDPD, PF.IDLANCDTMENFIL, NVL(PF.NRDIASSAIDFIL,0) AS NRDIASSAIDFIL, PF.IDLANCDTMAIFIL, NVL(PF.NRDIASSAIDPDFIL,0) AS NRDIASSAIDPDFIL,
                       PP.CDFILIAL, PP.IDEXIBESALDOESTRETI, PF.IDESTONLINE, PF.IDCTRLESTQ, PF.IDUTILALMOX, PF.IDUTILLOTE, TP.CDTIPOOPER,
                       PP.IDUTREQUPRAT, PP.CDTPRETIPADR, PP.CDSERVRETPME, NVL(PF.CDTIPCUSTEST, '03') CDTIPCUSTEST, PF.IDPERMVISPOSEST, PP.IDCARDIFRETI
                  FROM PARAMGERAL PG INNER JOIN PARAMFILIAL PF ON PF.NRORG = PG.NRORG AND PG.CDPARGERAL = '0001' 
                                     INNER JOIN PARAMESTOQUE PE ON PE.NRORG = PF.NRORG AND PE.CDPARESTOQ = '1' 
                                     LEFT JOIN TIPOOPERAC TP ON TP.NRORG = PF.NRORG AND TP.IDENTRSAIDOP = 'S' AND TP.CDTIPOOPER = '10' 
                                     LEFT JOIN PARAMPLANEJA PP ON PP.NRORG = PF.NRORG AND PP.CDFILIAL = PF.CDFILIAL 
                  WHERE PF.CDFILIAL = :CDFILIAL AND PF.NRORG = :NRORG";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute($params);
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function getCdNvProduto() {
    $sql = "SELECT MAX(CDNVPRODUTO)  as CDNVPRODUTO FROM PRODUTO";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute();
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
  
  public function testConnection() {
    $sql = "SELECT SYSDATE FROM DUAL";
    try{
      $std = $this->connection->prepare($sql);
      $std->execute();
      $result = $std->fetchAll();
      return $result;
    }catch(Exception $e) {
      throw $e; 
    }
  }
}